# decToUInt.s
# Converts decimal character string to unsigned int.
# Bob Plantz - 15 June 2009

# Calling sequence:
#       rdi <- address of decimal string to be converted
#       call    decToUInt
# returns 64-bit int represented by the decimal string

# Useful constants
        .equ    NUMERALMASK,0xf
        .equ    DECIMAL,10
# Stack frame, showing local variables and arguments
        .equ    accumulator,-8
        .equ    current,-1
        .equ    localSize,-16

        .text
        .globl  decToUInt
        .type   decToUInt, @function
decToUInt:
        pushq   %rbp             # save base pointer
        movq    %rsp, %rbp       # new base pointer
        addq    $localSize, %rsp # local vars. and arg.

        movl    $0, accumulator(%rbp)    # accumulator = 0;
loop:
        movb    (%rdi), %sil     # load character
        cmpb    $0, %sil         # at end yet?
        je      done             # yes, all done
 
        movl    $DECIMAL, %eax   # multiplier
        mull    accumulator(%rbp) # accumulator * 10
        movl    %eax, accumulator(%rbp) # update accumulator

        andl    $NUMERALMASK, %esi  # char -> int
        addl    %esi, accumulator(%rbp) # add the digit
        incq    %rdi             # stringPtr++;
        jmp     loop             # and check for end
done:
        movl    accumulator(%rbp), %eax  # return accumulator;
        movq    %rbp, %rsp      # restore stack pointer
        popq    %rbp            # restore base pointer
        ret                     # back to caller

