# fractionDisplay.s
# Displays a fraction in num/den format
# Bob Plantz - 18 June 2009
# Calling sequence:
#       rdi <- address of object
#       call    fractionDisplay
# Include object data definition
        .include "fraction.h"
# local register save area
        .equ    this,-8       # pointer to object
        .equ    localSize,-16
# Read only data
        .section  .rodata
slash:
        .string " / "
# Code
        .text
        .globl  fractionDisplay
        .type   fractionDisplay, @function
fractionDisplay:
        pushq   %rbp             # save frame pointer
        movq    %rsp, %rbp       # our frame pointer
        addq    $localSize, %rsp # local vars
        movq    %rdi, this(%rbp) # save this pointer

        movl	num(%rdi), %edi  # numerator
        call	putUint          # display it

        movq    $slash, %rdi     # "over"
        call    writeStr

        movq    this(%rbp), %rdi # get this pointer
        movl	den(%rdi), %edi  # denominator
        call	putUint          # display it

        movq    %rbp, %rsp       # delete local vars.
        popq    %rbp             # restore frame pointer
        ret                      # back to caller
