# intToUDec.s
# Converts unsigned int to corresponding unsigned decimal string
# Bob Plantz - 15 June 2009

# Calling sequence
#       esi <- value of the int
#       rdi <- address of place to store string
#       call intToUDec
# Useful constant
        .equ    asciiNumeral,0x30
# Stack frame
        .equ    reverseArray,-12
        .equ    localSize,-16
# Read only data
        .section .rodata
ten:    .long   10
# Code
        .text
        .globl  intToUDec
        .type   intToUDec, @function
intToUDec:
        pushq   %rbp            # save caller's base ptr
        movq    %rsp, %rbp      # our stack frame
        addq    $localSize, %rsp         # local char array

        movl    %esi, %eax      # eax used for division
        leaq    reverseArray(%rbp), %r8  # ptr to local array
        movb    $0, (%r8)       # store NUL
        incq    %r8             # increment pointer

        cmpl    $0, %eax        # integer == 0?
        jne     stringLup       # no, start on the string
        movb    $'0', (%r8)     # yes, this is the string
        incq    %r8             # for reverse copy
stringLup:
        cmpl    $0, %eax        # integer > 0?
        jbe     copyLup         # no, do reverse copy
        movl    $0, %edx        # yes, high-order = 0
        divl    ten             # divide by ten
        orb     $asciiNumeral, %dl # convert to ascii
        movb    %dl, (%r8)      # store character
        incq    %r8             # increment pointer
        jmp     stringLup       # check at top

copyLup:
        decq    %r8             # decrement pointer
        movb    (%r8), %dl      # get char
        movb    %dl, (%rdi)     # store it
        incq    %rdi            # increment storage pointer
        cmpb    $0, %dl         # NUL character?
        jne     copyLup         # no, keep copying

        movq    %rbp, %rsp      # delete local vars.
        popq    %rbp            # restore caller base ptr
        ret
