/*
 * intToUDec.c
 *
 * Converts an int to corresponding unsigned text
 * string representation.
 *
 * input:
 *    32-bit int
 *    pointer to at least 10-char array
 * output:
 *    null-terminated string in array
 *
 * Bob Plantz - 15 June 2009
 */

#include "intToUDec.h"
#define TOASCII 0x30

void intToUDec(char *decString, int theInt)
{
    unsigned int x = theInt;
    int base = 10;
    char reverseArray[10];
    char digit;
    char *ptr = reverseArray;
   
    *ptr = '\0';     // start with NUL
    ptr++;
    if (x == 0)      // zero case
    {
        *ptr = '0';
        ptr++;
    }
    while (x > 0)    // create the string
    {
        digit = x % base;
        x = x / base;
        digit = TOASCII | digit;
        *ptr = digit;
        ptr++;
    }
    do               // reverse the string
    {
        ptr--;
        *decString = *ptr;
        decString++;
    } while (*ptr != '\0');
}
